Index: libfaim/ssi.c
===================================================================
--- libfaim/ssi.c	(revision 862371bb6a5ff5a6491550028e73824b698508bb)
+++ libfaim/ssi.c	(revision e374dee70435f8c596358571092675644a9ba731)
@@ -1,12 +1,16 @@
 /*
- * Server-Side/Stored Information.
- *
- * Relatively new facility that allows storing of certain types of information,
- * such as a users buddy list, permit/deny list, and permit/deny preferences, 
- * to be stored on the server, so that they can be accessed from any client.
- *
- * We keep a copy of the ssi data in sess->ssi, because the data needs to be 
- * accessed for various reasons.  So all the "aim_ssi_itemlist_bleh" functions 
- * near the top just manage the local data.
+ * Family 0x0013 - Server-Side/Stored Information.
+ *
+ * Relatively new facility that allows certain types of information, such as 
+ * a user's buddy list, permit/deny list, and permit/deny preferences, to be 
+ * stored on the server, so that they can be accessed from any client.
+ *
+ * We keep 2 copies of SSI data:
+ * 1) An exact copy of what is stored on the AIM servers.
+ * 2) A local copy that we make changes to, and then send diffs 
+ *    between this and the exact copy to keep them in sync.
+ *
+ * All the "aim_ssi_itemlist_bleh" functions near the top just modify the list 
+ * that is given to them (i.e. they don't send SNACs).
  *
  * The SNAC sending and receiving functions are lower down in the file, and 
@@ -18,6 +22,5 @@
  * You don't know the half of it.
  *
- * XXX - Test for memory leaks
- * XXX - Better parsing of rights, and use the rights info to limit adds
+ * XXX - Preserve unknown data in TLV lists
  *
  */
@@ -27,140 +30,219 @@
 
 /**
+ * Locally rebuild the 0x00c8 TLV in the additional data of the given group.
+ *
+ * @param list A pointer to a pointer to the current list of items.
+ * @param name A null terminated string containing the group name, or NULL 
+ *        if you want to modify the master group.
+ * @return Return a pointer to the modified item.
+ */
+static struct aim_ssi_item *aim_ssi_itemlist_rebuildgroup(struct aim_ssi_item *list, const char *name)
+{
+	int newlen;
+	struct aim_ssi_item *cur, *group;
+
+	if (!list)
+		return NULL;
+
+	/* Find the group */
+	if (!(group = aim_ssi_itemlist_finditem(list, name, NULL, AIM_SSI_TYPE_GROUP)))
+		return NULL;
+
+	/* Free the old data */
+	aim_freetlvchain(&group->data);
+	group->data = NULL;
+
+	/* Find the length for the new additional data */
+	newlen = 0;
+	if (group->gid == 0x0000) {
+		for (cur=list; cur; cur=cur->next)
+			if ((cur->type == AIM_SSI_TYPE_GROUP) && (cur->gid != 0x0000))
+				newlen += 2;
+	} else {
+		for (cur=list; cur; cur=cur->next)
+			if ((cur->gid == group->gid) && (cur->type == AIM_SSI_TYPE_BUDDY))
+				newlen += 2;
+	}
+
+	/* Build the new TLV list */
+	if (newlen > 0) {
+		fu8_t *newdata;
+
+		if (!(newdata = (fu8_t *)malloc((newlen)*sizeof(fu8_t))))
+			return NULL;
+		newlen = 0;
+		if (group->gid == 0x0000) {
+			for (cur=list; cur; cur=cur->next)
+				if ((cur->type == AIM_SSI_TYPE_GROUP) && (cur->gid != 0x0000))
+						newlen += aimutil_put16(newdata+newlen, cur->gid);
+		} else {
+			for (cur=list; cur; cur=cur->next)
+				if ((cur->gid == group->gid) && (cur->type == AIM_SSI_TYPE_BUDDY))
+						newlen += aimutil_put16(newdata+newlen, cur->bid);
+		}
+		aim_addtlvtochain_raw(&group->data, 0x00c8, newlen, newdata);
+
+		free(newdata);
+	}
+
+	return group;
+}
+
+/**
  * Locally add a new item to the given item list.
  *
  * @param list A pointer to a pointer to the current list of items.
- * @param parent A pointer to the parent group, or NULL if the item should have no 
- *        parent group (ie. the group ID# should be 0).
  * @param name A null terminated string of the name of the new item, or NULL if the 
  *        item should have no name.
- * @param type The type of the item, 0x0001 for a contact, 0x0002 for a group, etc.
- * @return The newly created item.
- */
-static struct aim_ssi_item *aim_ssi_itemlist_add(struct aim_ssi_item **list, struct aim_ssi_item *parent, const char *name, fu16_t type)
+ * @param gid The group ID# you want the new item to have, or 0xFFFF if we should pick something.
+ * @param bid The buddy ID# you want the new item to have, or 0xFFFF if we should pick something.
+ * @param type The type of the item, 0x0000 for a contact, 0x0001 for a group, etc.
+ * @param data The additional data for the new item.
+ * @return A pointer to the newly created item.
+ */
+static struct aim_ssi_item *aim_ssi_itemlist_add(struct aim_ssi_item **list, const char *name, fu16_t gid, fu16_t bid, fu16_t type, aim_tlvlist_t *data)
 {
 	int i;
-	struct aim_ssi_item *cur, *newitem;
-
-	if (!(newitem = (struct aim_ssi_item *)malloc(sizeof(struct aim_ssi_item))))
+	struct aim_ssi_item *cur, *new;
+
+	if (!list)
+		return NULL;
+
+	if (!(new = (struct aim_ssi_item *)malloc(sizeof(struct aim_ssi_item))))
 		return NULL;
 
 	/* Set the name */
 	if (name) {
-		if (!(newitem->name = (char *)malloc((strlen(name)+1)*sizeof(char)))) {
-			free(newitem);
-			return NULL;
-		}
-		strcpy(newitem->name, name);
+		new->name = (char *)malloc((strlen(name)+1)*sizeof(char));
+		strcpy(new->name, name);
 	} else
-		newitem->name = NULL;
-
-	/* Set the group ID# and the buddy ID# */
-	newitem->gid = 0x0000;
-	newitem->bid = 0x0000;
+		new->name = NULL;
+
+	/* Set the group ID# and buddy ID# */
+	new->gid = gid;
+	new->bid = bid;
 	if (type == AIM_SSI_TYPE_GROUP) {
-		if (name)
+		if ((new->gid == 0xFFFF) && name) {
 			do {
-				newitem->gid += 0x0001;
+				new->gid += 0x0001;
 				for (cur=*list, i=0; ((cur) && (!i)); cur=cur->next)
-					if ((cur->gid == newitem->gid) && (cur->gid == newitem->gid))
+					if ((cur->type == AIM_SSI_TYPE_GROUP) && (cur->gid == new->gid))
 						i=1;
 			} while (i);
+		}
 	} else {
-		if (parent)
-			newitem->gid = parent->gid;
-		do {
-			newitem->bid += 0x0001;
-			for (cur=*list, i=0; ((cur) && (!i)); cur=cur->next)
-				if ((cur->bid == newitem->bid) && (cur->gid == newitem->gid))
-					i=1;
-		} while (i);
-	}
-
-	/* Set the rest */
-	newitem->type = type;
-	newitem->data = NULL;
-	newitem->next = *list;
-	*list = newitem;
-
-	return newitem;
-}
-
-/**
- * Locally rebuild the 0x00c8 TLV in the additional data of the given group.
+		if (new->bid == 0xFFFF) {
+			do {
+				new->bid += 0x0001;
+				for (cur=*list, i=0; ((cur) && (!i)); cur=cur->next)
+					if ((cur->bid == new->bid) && (cur->gid == new->gid))
+						i=1;
+			} while (i);
+		}
+	}
+
+	/* Set the type */
+	new->type = type;
+
+	/* Set the TLV list */
+	new->data = aim_tlvlist_copy(data);
+
+	/* Add the item to the list in the correct numerical position.  Fancy, eh? */
+	if (*list) {
+		if ((new->gid < (*list)->gid) || ((new->gid == (*list)->gid) && (new->bid < (*list)->bid))) {
+			new->next = *list;
+			*list = new;
+		} else {
+			struct aim_ssi_item *prev;
+			for ((prev=*list, cur=(*list)->next); (cur && ((new->gid > cur->gid) || ((new->gid == cur->gid) && (new->bid > cur->bid)))); prev=cur, cur=cur->next);
+			new->next = prev->next;
+			prev->next = new;
+		}
+	} else {
+		new->next = *list;
+		*list = new;
+	}
+
+	return new;
+}
+
+/**
+ * Locally delete an item from the given item list.
  *
  * @param list A pointer to a pointer to the current list of items.
- * @param parentgroup A pointer to the group who's additional data you want to rebuild.
+ * @param del A pointer to the item you want to remove from the list.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-static int aim_ssi_itemlist_rebuildgroup(struct aim_ssi_item **list, struct aim_ssi_item *parentgroup)
-{
-	int newlen;
+static int aim_ssi_itemlist_del(struct aim_ssi_item **list, struct aim_ssi_item *del)
+{
+	if (!list || !(*list) || !del)
+		return -EINVAL;
+
+	/* Remove the item from the list */
+	if (*list == del) {
+		*list = (*list)->next;
+	} else {
+		struct aim_ssi_item *cur;
+		for (cur=*list; (cur->next && (cur->next!=del)); cur=cur->next);
+		if (cur->next)
+			cur->next = cur->next->next;
+	}
+
+	/* Free the deleted item */
+	free(del->name);
+	aim_freetlvchain(&del->data);
+	free(del);
+
+	return 0;
+}
+
+/**
+ * Compare two items to see if they have the same data.
+ *
+ * @param cur1 A pointer to a pointer to the first item.
+ * @param cur2 A pointer to a pointer to the second item.
+ * @return Return 0 if no differences, or a number if there are differences.
+ */
+static int aim_ssi_itemlist_cmp(struct aim_ssi_item *cur1, struct aim_ssi_item *cur2)
+{
+	if (!cur1 || !cur2)
+		return 1;
+
+	if (cur1->data && !cur2->data)
+		return 2;
+
+	if (!cur1->data && cur2->data)
+		return 3;
+
+	if ((cur1->data && cur2->data) && (aim_tlvlist_cmp(cur1->data, cur2->data)))
+			return 4;
+
+	if (cur1->name && !cur2->name)
+		return 5;
+
+	if (!cur1->name && cur2->name)
+		return 6;
+
+	if (cur1->name && cur2->name && aim_sncmp(cur1->name, cur2->name))
+		return 7;
+
+	if (cur1->gid != cur2->gid)
+		return 8;
+
+	if (cur1->bid != cur2->bid)
+		return 9;
+
+	if (cur1->type != cur2->type)
+		return 10;
+
+	return 0;
+}
+
+faim_export int aim_ssi_itemlist_valid(struct aim_ssi_item *list, struct aim_ssi_item *item)
+{
 	struct aim_ssi_item *cur;
-
-	/* Free the old additional data */
-	if (parentgroup->data) {
-		aim_freetlvchain((aim_tlvlist_t **)&parentgroup->data);
-		parentgroup->data = NULL;
-	}
-
-	/* Find the length for the new additional data */
-	newlen = 0;
-	if (parentgroup->gid == 0x0000) {
-		for (cur=*list; cur; cur=cur->next)
-			if ((cur->gid != 0x0000) && (cur->type == AIM_SSI_TYPE_GROUP))
-				newlen += 2;
-	} else {
-		for (cur=*list; cur; cur=cur->next)
-			if ((cur->gid == parentgroup->gid) && (cur->type == AIM_SSI_TYPE_BUDDY))
-				newlen += 2;
-	}
-
-	/* Rebuild the additional data */
-	if (newlen>0) {
-		fu8_t *newdata;
-
-		if (!(newdata = (fu8_t *)malloc((newlen)*sizeof(fu8_t))))
-			return -ENOMEM;
-		newlen = 0;
-		if (parentgroup->gid == 0x0000) {
-			for (cur=*list; cur; cur=cur->next)
-				if ((cur->gid != 0x0000) && (cur->type == AIM_SSI_TYPE_GROUP))
-						newlen += aimutil_put16(newdata+newlen, cur->gid);
-		} else {
-			for (cur=*list; cur; cur=cur->next)
-				if ((cur->gid == parentgroup->gid) && (cur->type == AIM_SSI_TYPE_BUDDY))
-						newlen += aimutil_put16(newdata+newlen, cur->bid);
-		}
-		aim_addtlvtochain_raw((aim_tlvlist_t **)&(parentgroup->data), 0x00c8, newlen, newdata);
-
-		free(newdata);
-	}
-
-	return 0;
-}
-
-/**
- * Locally free all of the stored buddy list information.
- *
- * @param sess The oscar session.
- * @return Return 0 if no errors, otherwise return the error number.
- */
-static int aim_ssi_freelist(aim_session_t *sess)
-{
-	struct aim_ssi_item *cur, *delitem;
-
-	cur = sess->ssi.items;
-	while (cur) {
-		if (cur->name)  free(cur->name);
-		if (cur->data)  aim_freetlvchain((aim_tlvlist_t **)&cur->data);
-		delitem = cur;
-		cur = cur->next;
-		free(delitem);
-	}
-
-	sess->ssi.items = NULL;
-	sess->ssi.revision = 0;
-	sess->ssi.timestamp = (time_t)0;
-
+	for (cur=list; cur; cur=cur->next)
+		if (cur == item)
+			return 1;
 	return 0;
 }
@@ -208,15 +290,42 @@
 			}
 
-	} else if (sn) { /* For finding groups, permits, denies, and ignores */
-		for (cur=list; cur; cur=cur->next)
-			if ((cur->type == type) && (cur->name) && !(aim_sncmp(cur->name, sn)))
+	} else if (gn) { /* For finding groups */
+		for (cur=list; cur; cur=cur->next) {
+			if ((cur->type == type) && (cur->bid == 0x0000) && (cur->name) && !(aim_sncmp(cur->name, gn))) {
 				return cur;
+			}
+		}
+
+	} else if (sn) { /* For finding permits, denies, and ignores */
+		for (cur=list; cur; cur=cur->next) {
+			if ((cur->type == type) && (cur->name) && !(aim_sncmp(cur->name, sn))) {
+				return cur;
+			}
+		}
 
 	/* For stuff without names--permit deny setting, visibility mask, etc. */
 	} else for (cur=list; cur; cur=cur->next) {
-		if (cur->type == type)
+		if ((cur->type == type) && (!cur->name))
 			return cur;
 	}
 
+	return NULL;
+}
+
+/**
+ * Check if the given buddy exists in any group in the buddy list.
+ *
+ * @param list A pointer to the current list of items.
+ * @param sn The group name of the desired item.
+ * @return Return a pointer to the name of the item if found, else return NULL;
+ */
+faim_export struct aim_ssi_item *aim_ssi_itemlist_exists(struct aim_ssi_item *list, const char *sn)
+{
+	struct aim_ssi_item *cur;
+	if (!list || !sn)
+		return NULL;
+	for (cur=list; cur; cur=cur->next)
+		if ((cur->type == AIM_SSI_TYPE_BUDDY) && (cur->name) && (!aim_sncmp(cur->name, sn)))
+			return cur;
 	return NULL;
 }
@@ -227,17 +336,16 @@
  * @param list A pointer to the current list of items.
  * @param bn The buddy name of the desired item.
- * @return Return a pointer to the item if found, else return NULL;
- */
-faim_export struct aim_ssi_item *aim_ssi_itemlist_findparent(struct aim_ssi_item *list, char *sn)
+ * @return Return a pointer to the name of the item if found, else return NULL;
+ */
+faim_export char *aim_ssi_itemlist_findparentname(struct aim_ssi_item *list, const char *sn)
 {
 	struct aim_ssi_item *cur, *curg;
 	if (!list || !sn)
 		return NULL;
-	if (!(cur = aim_ssi_itemlist_finditem(list, NULL, sn, AIM_SSI_TYPE_BUDDY)))
+	if (!(cur = aim_ssi_itemlist_exists(list, sn)))
 		return NULL;
-	for (curg=list; curg; curg=curg->next)
-		if ((curg->type == AIM_SSI_TYPE_GROUP) && (curg->gid == cur->gid))
-			return curg;
-	return NULL;
+	if (!(curg = aim_ssi_itemlist_find(list, cur->gid, 0x0000)))
+		return NULL;
+	return curg->name;
 }
 
@@ -285,395 +393,483 @@
 
 /**
- * Add the given packet to the holding queue.  We totally need to send SSI SNACs one at 
- * a time, so we have a local queue where packets get put before they are sent, and 
- * then we send stuff one at a time, nice and orderly-like.
+ * Locally find the alias of the given buddy.
+ *
+ * @param list A pointer to the current list of items.
+ * @param gn The group of the buddy.
+ * @param sn The name of the buddy.
+ * @return A pointer to a NULL terminated string that is the buddies 
+ *         alias, or NULL if the buddy has no alias.  You should free
+ *         this returned value!
+ */
+faim_export char *aim_ssi_getalias(struct aim_ssi_item *list, const char *gn, const char *sn)
+{
+	struct aim_ssi_item *cur = aim_ssi_itemlist_finditem(list, gn, sn, AIM_SSI_TYPE_BUDDY);
+	if (cur) {
+		aim_tlvlist_t *tlvlist = cur->data;
+		if (tlvlist) {
+			aim_tlv_t *tlv = aim_gettlv(tlvlist, 0x0131, 1);
+			if (tlv && tlv->length) {
+				char *alias = (char *)malloc((tlv->length+1)*sizeof(char));
+				strncpy(alias, tlv->value, tlv->length);
+				alias[tlv->length] = 0;
+				return alias;
+			}
+		}
+	}
+	return NULL;
+}
+
+/**
+ * Locally find if you are waiting for authorization for a buddy.
+ *
+ * @param list A pointer to the current list of items.
+ * @param gn The group of the buddy.
+ * @param sn The name of the buddy.
+ * @return A pointer to a NULL terminated string that is the buddies 
+ *         alias, or NULL if the buddy has no alias.  You should free
+ *         this returned value!
+ */
+faim_export int aim_ssi_waitingforauth(struct aim_ssi_item *list, const char *gn, const char *sn)
+{
+	struct aim_ssi_item *cur = aim_ssi_itemlist_finditem(list, gn, sn, AIM_SSI_TYPE_BUDDY);
+	if (cur) {
+		aim_tlvlist_t *tlvlist = cur->data;
+		if (tlvlist)
+			if (aim_gettlv(tlvlist, 0x0066, 1))
+				return 1;
+	}
+	return 0;
+}
+
+/**
+ * If there are changes, then create temporary items and 
+ * call addmoddel.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param fr The newly created SNAC that you want to send.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-static int aim_ssi_enqueue(aim_session_t *sess, aim_conn_t *conn, aim_frame_t *fr)
-{
-	aim_frame_t *cur;
-
-	if (!sess || !conn || !fr)
-		return -EINVAL;
-
-	fr->next = NULL;
-	if (sess->ssi.holding_queue == NULL) {
-		sess->ssi.holding_queue = fr;
-		if (!sess->ssi.waiting_for_ack)
-			aim_ssi_modbegin(sess, conn);
-	} else {
-		for (cur = sess->ssi.holding_queue; cur->next; cur = cur->next) ;
-		cur->next = fr;
-	}
-
-	return 0;
-}
-
-/**
- * Send the next SNAC from the holding queue.  This is called 
- * automatically when an ack from an add, mod, or del is received.  
- * If the queue is empty, it sends the modend SNAC.
+static int aim_ssi_sync(aim_session_t *sess)
+{
+	struct aim_ssi_item *cur1, *cur2;
+	struct aim_ssi_tmp *cur, *new;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* If we're waiting for an ack, we shouldn't do anything else */
+	if (sess->ssi.waiting_for_ack)
+		return 0;
+
+	/*
+	 * Compare the 2 lists and create an aim_ssi_tmp for each difference.  
+	 * We should only send either additions, modifications, or deletions 
+	 * before waiting for an acknowledgement.  So first do deletions, then 
+	 * additions, then modifications.  Also, both the official and the local 
+	 * list should be in ascending numerical order for the group ID#s and the 
+	 * buddy ID#s, which makes things more efficient.  I think.
+	 */
+
+	/* Additions */
+	if (!sess->ssi.pending) {
+		for (cur1=sess->ssi.local; cur1; cur1=cur1->next) {
+			if (!aim_ssi_itemlist_find(sess->ssi.official, cur1->gid, cur1->bid)) {
+				new = (struct aim_ssi_tmp *)malloc(sizeof(struct aim_ssi_tmp));
+				new->action = AIM_CB_SSI_ADD;
+				new->ack = 0xffff;
+				new->name = NULL;
+				new->item = cur1;
+				new->next = NULL;
+				if (sess->ssi.pending) {
+					for (cur=sess->ssi.pending; cur->next; cur=cur->next);
+					cur->next = new;
+				} else
+					sess->ssi.pending = new;
+			}
+		}
+	}
+
+	/* Deletions */
+	if (!sess->ssi.pending) {
+		for (cur1=sess->ssi.official; cur1; cur1=cur1->next) {
+			if (!aim_ssi_itemlist_find(sess->ssi.local, cur1->gid, cur1->bid)) {
+				new = (struct aim_ssi_tmp *)malloc(sizeof(struct aim_ssi_tmp));
+				new->action = AIM_CB_SSI_DEL;
+				new->ack = 0xffff;
+				new->name = NULL;
+				new->item = cur1;
+				new->next = NULL;
+				if (sess->ssi.pending) {
+					for (cur=sess->ssi.pending; cur->next; cur=cur->next);
+					cur->next = new;
+				} else
+					sess->ssi.pending = new;
+			}
+		}
+	}
+
+	/* Modifications */
+	if (!sess->ssi.pending) {
+		for (cur1=sess->ssi.local; cur1; cur1=cur1->next) {
+			cur2 = aim_ssi_itemlist_find(sess->ssi.official, cur1->gid, cur1->bid);
+			if (cur2 && (aim_ssi_itemlist_cmp(cur1, cur2))) {
+				new = (struct aim_ssi_tmp *)malloc(sizeof(struct aim_ssi_tmp));
+				new->action = AIM_CB_SSI_MOD;
+				new->ack = 0xffff;
+				new->name = NULL;
+				new->item = cur1;
+				new->next = NULL;
+				if (sess->ssi.pending) {
+					for (cur=sess->ssi.pending; cur->next; cur=cur->next);
+					cur->next = new;
+				} else
+					sess->ssi.pending = new;
+			}
+		}
+	}
+
+	/* We're out of stuff to do, so tell the AIM servers we're done and exit */
+	if (!sess->ssi.pending) {
+		aim_ssi_modend(sess);
+		return 0;
+	}
+
+	/* Make sure we don't send anything else between now 
+	 * and when we receive the ack for the following operation */
+	sess->ssi.waiting_for_ack = 1;
+
+	/* Now go mail off our data and wait 4 to 6 weeks */
+	aim_ssi_addmoddel(sess);
+
+	return 0;
+}
+
+/**
+ * Free all SSI data.
+ *
+ * This doesn't remove it from the server, that's different.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-static int aim_ssi_dispatch(aim_session_t *sess, aim_conn_t *conn)
-{
-	aim_frame_t *cur;
-
-	if (!sess || !conn)
-		return -EINVAL;
-
-	if (!sess->ssi.waiting_for_ack) {
-		if (sess->ssi.holding_queue) {
-			sess->ssi.waiting_for_ack = 1;
-			cur = sess->ssi.holding_queue->next;
-			sess->ssi.holding_queue->next = NULL;
-			aim_tx_enqueue(sess, sess->ssi.holding_queue);
-			sess->ssi.holding_queue = cur;
-		} else
-			aim_ssi_modend(sess, conn);
-	}
-
-	return 0;
-}
-
-/**
- * Send SNACs necessary to remove all SSI data from the server list, 
- * and then free the local copy as well.
+static int aim_ssi_freelist(aim_session_t *sess)
+{
+	struct aim_ssi_item *cur, *del;
+	struct aim_ssi_tmp *curtmp, *deltmp;
+
+	cur = sess->ssi.official;
+	while (cur) {
+		del = cur;
+		cur = cur->next;
+		free(del->name);
+		aim_freetlvchain(&del->data);
+		free(del);
+	}
+
+	cur = sess->ssi.local;
+	while (cur) {
+		del = cur;
+		cur = cur->next;
+		free(del->name);
+		aim_freetlvchain(&del->data);
+		free(del);
+	}
+
+	curtmp = sess->ssi.pending;
+	while (curtmp) {
+		deltmp = curtmp;
+		curtmp = curtmp->next;
+		free(deltmp);
+	}
+
+	sess->ssi.numitems = 0;
+	sess->ssi.official = NULL;
+	sess->ssi.local = NULL;
+	sess->ssi.pending = NULL;
+	sess->ssi.timestamp = (time_t)0;
+
+	return 0;
+}
+
+/**
+ * Delete all SSI data.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_deletelist(aim_session_t *sess, aim_conn_t *conn)
-{
-	int num;
-	struct aim_ssi_item *cur, **items;
-
-	for (cur=sess->ssi.items, num=0; cur; cur=cur->next)
-		num++;
-
-	if (!(items = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *))))
-		return -ENOMEM;
-	memset(items, 0, num*sizeof(struct aim_ssi_item *));
-	for (cur=sess->ssi.items, num=0; cur; cur=cur->next) {
-		items[num] = cur;
-		num++;
-	}
-
-	aim_ssi_addmoddel(sess, conn, items, num, AIM_CB_SSI_DEL);
-	free(items);
-	aim_ssi_dispatch(sess, conn);
-	aim_ssi_freelist(sess);
-
-	return 0;
-}
-
-/**
- * This "cleans" the ssi list.  It does a few things, with the intent of making 
- * sure there ain't nothin' wrong with your SSI.
- *   -Make sure all buddies are in a group, and all groups have the correct 
- *     additional data.
- *   -Make sure there are no empty groups in the list.  While there is nothing 
- *     wrong empty groups in the SSI, it's wiser to not have them.
+faim_export int aim_ssi_deletelist(aim_session_t *sess)
+{
+	struct aim_ssi_item *cur, *del;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Free the local list */
+	cur = sess->ssi.local;
+	while (cur) {
+		del = cur;
+		cur = cur->next;
+		free(del->name);
+		aim_freetlvchain(&del->data);
+		free(del);
+	}
+	sess->ssi.local = NULL;
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * This "cleans" the ssi list.  It does the following:
+ * 1) Makes sure all buddies, permits, and denies have names.
+ * 2) Makes sure that all buddies are in a group that exist.
+ * 3) Deletes any empty groups
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_cleanlist(aim_session_t *sess, aim_conn_t *conn)
-{
-	unsigned int i;
-	struct aim_ssi_item *cur, *parentgroup;
-
-	/* Make sure we actually need to clean out the list */
-	for (cur=sess->ssi.items, i=0; cur && !i; cur=cur->next)
-		/* Any buddies directly in the master group */
-		if ((cur->type == AIM_SSI_TYPE_BUDDY) && (cur->gid == 0x0000))
-			i++;
-	if (!i)
-		return 0;
-
-	/* Remove all the additional data from all groups */
-	for (cur=sess->ssi.items; cur; cur=cur->next)
-		if ((cur->data) && (cur->type == AIM_SSI_TYPE_GROUP)) {
-			aim_freetlvchain((aim_tlvlist_t **)&cur->data);
-			cur->data = NULL;
+faim_export int aim_ssi_cleanlist(aim_session_t *sess)
+{
+	struct aim_ssi_item *cur, *next;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Delete any buddies, permits, or denies with empty names. */
+	/* If there are any buddies directly in the master group, add them to a real group. */
+	/* DESTROY any buddies that are directly in the master group. */
+	/* Do the same for buddies that are in a non-existant group. */
+	/* This will kind of mess up if you hit the item limit, but this function isn't too critical */
+	cur = sess->ssi.local;
+	while (cur) {
+		next = cur->next;
+		if (!cur->name) {
+			if (cur->type == AIM_SSI_TYPE_BUDDY)
+				aim_ssi_delbuddy(sess, NULL, NULL);
+			else if (cur->type == AIM_SSI_TYPE_PERMIT)
+				aim_ssi_delpermit(sess, NULL);
+			else if (cur->type == AIM_SSI_TYPE_DENY)
+				aim_ssi_deldeny(sess, NULL);
+		} else if ((cur->type == AIM_SSI_TYPE_BUDDY) && ((cur->gid == 0x0000) || (!aim_ssi_itemlist_find(sess->ssi.local, cur->gid, 0x0000)))) {
+			aim_ssi_addbuddy(sess, cur->name, "orphans", NULL, NULL, NULL, 0);
+			aim_ssi_delbuddy(sess, cur->name, NULL);
 		}
-
-	/* If there are buddies directly in the master group, make sure  */
-	/* there is a group to put them in.  Any group, any group at all. */
-	for (cur=sess->ssi.items; ((cur) && ((cur->type != AIM_SSI_TYPE_BUDDY) || (cur->gid != 0x0000))); cur=cur->next);
-	if (!cur) {
-		for (parentgroup=sess->ssi.items; ((parentgroup) && (parentgroup->type!=AIM_SSI_TYPE_GROUP) && (parentgroup->gid==0x0000)); parentgroup=parentgroup->next);
-		if (!parentgroup) {
-			char *newgroup;
-			newgroup = (char*)malloc(strlen("Unknown")*sizeof(char));
-			strcpy(newgroup, "Unknown");
-			aim_ssi_addgroups(sess, conn, (const char**)&newgroup, 1);
+		cur = next;
+	}
+
+	/* Check if there are empty groups and delete them */
+	cur = sess->ssi.local;
+	while (cur) {
+		next = cur->next;
+		if (cur->type == AIM_SSI_TYPE_GROUP) {
+			aim_tlv_t *tlv = aim_gettlv(cur->data, 0x00c8, 1);
+			if (!tlv || !tlv->length)
+				aim_ssi_itemlist_del(&sess->ssi.local, cur);
 		}
-	}
-
-	/* Set parentgroup equal to any arbitray group */
-	for (parentgroup=sess->ssi.items; parentgroup->gid==0x0000 || parentgroup->type!=AIM_SSI_TYPE_GROUP; parentgroup=parentgroup->next);
-
-	/* If there are any buddies directly in the master group, put them in a real group */
-	for (cur=sess->ssi.items; cur; cur=cur->next)
-		if ((cur->type == AIM_SSI_TYPE_BUDDY) && (cur->gid == 0x0000)) {
-			aim_ssi_addmoddel(sess, conn, &cur, 1, AIM_CB_SSI_DEL);
-			cur->gid = parentgroup->gid;
-			aim_ssi_addmoddel(sess, conn, &cur, 1, AIM_CB_SSI_ADD);
+		cur = next;
+	}
+
+	/* Check if the master group is empty */
+	if ((cur = aim_ssi_itemlist_find(sess->ssi.local, 0x0000, 0x0000)) && (!cur->data))
+		aim_ssi_itemlist_del(&sess->ssi.local, cur);
+
+	return 0;
+}
+
+/**
+ * Add a buddy to the list.
+ *
+ * @param sess The oscar session.
+ * @param name The name of the item.
+ * @param group The group of the item.
+ * @param alias The alias/nickname of the item, or NULL.
+ * @param comment The buddy comment for the item, or NULL.
+ * @param smsnum The locally assigned SMS number, or NULL.
+ * @return Return 0 if no errors, otherwise return the error number.
+ */
+faim_export int aim_ssi_addbuddy(aim_session_t *sess, const char *name, const char *group, const char *alias, const char *comment, const char *smsnum, int needauth)
+{
+	struct aim_ssi_item *parent;
+	aim_tlvlist_t *data = NULL;
+
+	if (!sess || !name || !group)
+		return -EINVAL;
+
+	/* Find the parent */
+	if (!(parent = aim_ssi_itemlist_finditem(sess->ssi.local, group, NULL, AIM_SSI_TYPE_GROUP))) {
+		/* Find the parent's parent (the master group) */
+		if (!(parent = aim_ssi_itemlist_find(sess->ssi.local, 0x0000, 0x0000)))
+			if (!(parent = aim_ssi_itemlist_add(&sess->ssi.local, NULL, 0x0000, 0x0000, AIM_SSI_TYPE_GROUP, NULL)))
+				return -ENOMEM;
+		/* Add the parent */
+		if (!(parent = aim_ssi_itemlist_add(&sess->ssi.local, group, 0xFFFF, 0x0000, AIM_SSI_TYPE_GROUP, NULL)))
+			return -ENOMEM;
+
+		/* Modify the parent's parent (the master group) */
+		aim_ssi_itemlist_rebuildgroup(sess->ssi.local, NULL);
+	}
+
+	/* Create a TLV list for the new buddy */
+	if (needauth)
+		aim_addtlvtochain_noval(&data, 0x0066);
+	if (alias)
+		aim_addtlvtochain_raw(&data, 0x0131, strlen(alias), alias);
+	if (smsnum)
+		aim_addtlvtochain_raw(&data, 0x013a, strlen(smsnum), smsnum);
+	if (comment)
+		aim_addtlvtochain_raw(&data, 0x013c, strlen(comment), comment);
+
+	/* Add that bad boy */
+	aim_ssi_itemlist_add(&sess->ssi.local, name, parent->gid, 0xFFFF, AIM_SSI_TYPE_BUDDY, data);
+	aim_freetlvchain(&data);
+
+	/* Modify the parent group */
+	aim_ssi_itemlist_rebuildgroup(sess->ssi.local, group);
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Add a permit buddy to the list.
+ *
+ * @param sess The oscar session.
+ * @param name The name of the item..
+ * @return Return 0 if no errors, otherwise return the error number.
+ */
+faim_export int aim_ssi_addpermit(aim_session_t *sess, const char *name)
+{
+
+	if (!sess || !name)
+		return -EINVAL;
+
+	/* Add that bad boy */
+	aim_ssi_itemlist_add(&sess->ssi.local, name, 0x0000, 0xFFFF, AIM_SSI_TYPE_PERMIT, NULL);
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Add a deny buddy to the list.
+ *
+ * @param sess The oscar session.
+ * @param name The name of the item..
+ * @return Return 0 if no errors, otherwise return the error number.
+ */
+faim_export int aim_ssi_adddeny(aim_session_t *sess, const char *name)
+{
+
+	if (!sess || !name)
+		return -EINVAL;
+
+	/* Add that bad boy */
+	aim_ssi_itemlist_add(&sess->ssi.local, name, 0x0000, 0xFFFF, AIM_SSI_TYPE_DENY, NULL);
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Deletes a buddy from the list.
+ *
+ * @param sess The oscar session.
+ * @param name The name of the item, or NULL.
+ * @param group The group of the item, or NULL.
+ * @return Return 0 if no errors, otherwise return the error number.
+ */
+faim_export int aim_ssi_delbuddy(aim_session_t *sess, const char *name, const char *group)
+{
+	struct aim_ssi_item *del;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Find the buddy */
+	if (!(del = aim_ssi_itemlist_finditem(sess->ssi.local, group, name, AIM_SSI_TYPE_BUDDY)))
+		return -EINVAL;
+
+	/* Remove the item from the list */
+	aim_ssi_itemlist_del(&sess->ssi.local, del);
+
+	/* Modify the parent group */
+	aim_ssi_itemlist_rebuildgroup(sess->ssi.local, group);
+
+	/* Check if we should delete the parent group */
+	if ((del = aim_ssi_itemlist_finditem(sess->ssi.local, group, NULL, AIM_SSI_TYPE_GROUP)) && (!del->data)) {
+		aim_ssi_itemlist_del(&sess->ssi.local, del);
+
+		/* Modify the parent group */
+		aim_ssi_itemlist_rebuildgroup(sess->ssi.local, NULL);
+
+		/* Check if we should delete the parent's parent (the master group) */
+		if ((del = aim_ssi_itemlist_find(sess->ssi.local, 0x0000, 0x0000)) && (!del->data)) {
+			aim_ssi_itemlist_del(&sess->ssi.local, del);
 		}
-
-	/* Rebuild additional data for all groups */
-	for (parentgroup=sess->ssi.items; parentgroup; parentgroup=parentgroup->next)
-		if (parentgroup->type == AIM_SSI_TYPE_GROUP)
-			aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, parentgroup);
-
-	/* Send a mod snac for all groups */
-	i = 0;
-	for (cur=sess->ssi.items; cur; cur=cur->next)
-		if (cur->type == AIM_SSI_TYPE_GROUP)
-			i++;
-	if (i > 0) {
-		/* Allocate an array of pointers to each of the groups */
-		struct aim_ssi_item **groups;
-		if (!(groups = (struct aim_ssi_item **)malloc(i*sizeof(struct aim_ssi_item *))))
-			return -ENOMEM;
-
-		for (cur=sess->ssi.items, i=0; cur; cur=cur->next)
-			if (cur->type == AIM_SSI_TYPE_GROUP)
-				groups[i] = cur;
-
-		aim_ssi_addmoddel(sess, conn, groups, i, AIM_CB_SSI_MOD);
-		free(groups);
-	}
-
-	/* Send a del snac for any empty groups */
-	i = 0;
-	for (cur=sess->ssi.items; cur; cur=cur->next)
-		if ((cur->type == AIM_SSI_TYPE_GROUP) && !(cur->data))
-			i++;
-	if (i > 0) {
-		/* Allocate an array of pointers to each of the groups */
-		struct aim_ssi_item **groups;
-		if (!(groups = (struct aim_ssi_item **)malloc(i*sizeof(struct aim_ssi_item *))))
-			return -ENOMEM;
-
-		for (cur=sess->ssi.items, i=0; cur; cur=cur->next)
-			if ((cur->type == AIM_SSI_TYPE_GROUP) && !(cur->data))
-				groups[i] = cur;
-
-		aim_ssi_addmoddel(sess, conn, groups, i, AIM_CB_SSI_DEL);
-		free(groups);
-	}
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Add an array of screen names to the given group.
+	}
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Deletes a permit buddy from the list.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param gn The name of the group to which you want to add these names.
- * @param sn An array of null terminated strings of the names you want to add.
- * @param num The number of screen names you are adding (size of the sn array).
+ * @param name The name of the item, or NULL.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_addbuddies(aim_session_t *sess, aim_conn_t *conn, const char *gn, const char **sn, unsigned int num)
-{
-	struct aim_ssi_item *parentgroup, **newitems;
-	fu16_t i;
-
-	if (!sess || !conn || !gn || !sn || !num)
-		return -EINVAL;
-
-	/* Look up the parent group */
-	if (!(parentgroup = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, gn, AIM_SSI_TYPE_GROUP))) {
-		aim_ssi_addgroups(sess, conn, (const char **)&gn, 1);
-		if (!(parentgroup = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, gn, AIM_SSI_TYPE_GROUP)))
-			return -ENOMEM;
-	}
-
-	/* Allocate an array of pointers to each of the new items */
-	if (!(newitems = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *))))
-		return -ENOMEM;
-
-	/* Add items to the local list, and index them in the array */
-	for (i=0; i<num; i++)
-		if (!(newitems[i] = aim_ssi_itemlist_add(&sess->ssi.items, parentgroup, sn[i], AIM_SSI_TYPE_BUDDY))) {
-			free(newitems);
-			return -ENOMEM;
-		}
-
-	/* Send the add item SNAC */
-	if ((i = aim_ssi_addmoddel(sess, conn, newitems, num, AIM_CB_SSI_ADD))) {
-		free(newitems);
-		return -i;
-	}
-
-	/* Free the array of pointers to each of the new items */
-	free(newitems);
-
-	/* Rebuild the additional data in the parent group */
-	if ((i = aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, parentgroup)))
-		return i;
-
-	/* Send the mod item SNAC */
-	if ((i = aim_ssi_addmoddel(sess, conn, &parentgroup, 1, AIM_CB_SSI_MOD)))
-		return i;
-
-	/* Begin sending SSI SNACs */
-	if (!(i = aim_ssi_dispatch(sess, conn)))
-		return i;
-
-	return 0;
-}
-
-/**
- * Add the master group (the group containing all groups).  This is called by 
- * aim_ssi_addgroups, if necessary.
+faim_export int aim_ssi_delpermit(aim_session_t *sess, const char *name)
+{
+	struct aim_ssi_item *del;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Find the item */
+	if (!(del = aim_ssi_itemlist_finditem(sess->ssi.local, NULL, name, AIM_SSI_TYPE_PERMIT)))
+		return -EINVAL;
+
+	/* Remove the item from the list */
+	aim_ssi_itemlist_del(&sess->ssi.local, del);
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Deletes a deny buddy from the list.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
+ * @param name The name of the item, or NULL.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_addmastergroup(aim_session_t *sess, aim_conn_t *conn)
-{
-	struct aim_ssi_item *newitem;
-
-	if (!sess || !conn)
-		return -EINVAL;
-
-	/* Add the item to the local list, and keep a pointer to it */
-	if (!(newitem = aim_ssi_itemlist_add(&sess->ssi.items, NULL, NULL, AIM_SSI_TYPE_GROUP)))
-		return -ENOMEM;
-
-	/* If there are any existing groups (technically there shouldn't be, but */
-	/* just in case) then add their group ID#'s to the additional data */
-	aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, newitem);
-
-	/* Send the add item SNAC */
-	aim_ssi_addmoddel(sess, conn, &newitem, 1, AIM_CB_SSI_ADD);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Add an array of groups to the list.
- *
- * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param gn An array of null terminated strings of the names you want to add.
- * @param num The number of groups names you are adding (size of the sn array).
- * @return Return 0 if no errors, otherwise return the error number.
- */
-faim_export int aim_ssi_addgroups(aim_session_t *sess, aim_conn_t *conn, const char **gn, unsigned int num)
-{
-	struct aim_ssi_item *parentgroup, **newitems;
-	fu16_t i;
-
-	if (!sess || !conn || !gn || !num)
-		return -EINVAL;
-
-	/* Look up the parent group */
-	if (!(parentgroup = aim_ssi_itemlist_find(sess->ssi.items, 0, 0))) {
-		aim_ssi_addmastergroup(sess, conn);
-		if (!(parentgroup = aim_ssi_itemlist_find(sess->ssi.items, 0, 0)))
-			return -ENOMEM;
-	}
-
-	/* Allocate an array of pointers to each of the new items */
-	if (!(newitems = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *))))
-		return -ENOMEM;
-
-	/* Add items to the local list, and index them in the array */
-	for (i=0; i<num; i++)
-		if (!(newitems[i] = aim_ssi_itemlist_add(&sess->ssi.items, parentgroup, gn[i], AIM_SSI_TYPE_GROUP))) {
-			free(newitems);
-			return -ENOMEM;
-		}
-
-	/* Send the add item SNAC */
-	if ((i = aim_ssi_addmoddel(sess, conn, newitems, num, AIM_CB_SSI_ADD))) {
-		free(newitems);
-		return -i;
-	}
-
-	/* Free the array of pointers to each of the new items */
-	free(newitems);
-
-	/* Rebuild the additional data in the parent group */
-	if ((i = aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, parentgroup)))
-		return i;
-
-	/* Send the mod item SNAC */
-	if ((i = aim_ssi_addmoddel(sess, conn, &parentgroup, 1, AIM_CB_SSI_MOD)))
-		return i;
-
-	/* Begin sending SSI SNACs */
-	if (!(i = aim_ssi_dispatch(sess, conn)))
-		return i;
-
-	return 0;
-}
-
-/**
- * Add an array of a certain type of item to the list.  This can be used for 
- * permit buddies, deny buddies, ICQ's ignore buddies, and probably other 
- * types, also.
- *
- * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param sn An array of null terminated strings of the names you want to add.
- * @param num The number of groups names you are adding (size of the sn array).
- * @param type The type of item you want to add.  See the AIM_SSI_TYPE_BLEH 
- *        #defines in aim.h.
- * @return Return 0 if no errors, otherwise return the error number.
- */
-faim_export int aim_ssi_addpord(aim_session_t *sess, aim_conn_t *conn, const char **sn, unsigned int num, fu16_t type)
-{
-	struct aim_ssi_item **newitems;
-	fu16_t i;
-
-	if (!sess || !conn || !sn || !num)
-		return -EINVAL;
-
-	/* Allocate an array of pointers to each of the new items */
-	if (!(newitems = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *))))
-		return -ENOMEM;
-
-	/* Add items to the local list, and index them in the array */
-	for (i=0; i<num; i++)
-		if (!(newitems[i] = aim_ssi_itemlist_add(&sess->ssi.items, NULL, sn[i], type))) {
-			free(newitems);
-			return -ENOMEM;
-		}
-
-	/* Send the add item SNAC */
-	if ((i = aim_ssi_addmoddel(sess, conn, newitems, num, AIM_CB_SSI_ADD))) {
-		free(newitems);
-		return -i;
-	}
-
-	/* Free the array of pointers to each of the new items */
-	free(newitems);
-
-	/* Begin sending SSI SNACs */
-	if (!(i = aim_ssi_dispatch(sess, conn)))
-		return i;
+faim_export int aim_ssi_deldeny(aim_session_t *sess, const char *name)
+{
+	struct aim_ssi_item *del;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Find the item */
+	if (!(del = aim_ssi_itemlist_finditem(sess->ssi.local, NULL, name, AIM_SSI_TYPE_DENY)))
+		return -EINVAL;
+
+	/* Remove the item from the list */
+	aim_ssi_itemlist_del(&sess->ssi.local, del);
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
 
 	return 0;
@@ -685,5 +881,4 @@
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
  * @param oldgn The group that the buddy is currently in.
  * @param newgn The group that the buddy should be moved in to.
@@ -691,358 +886,79 @@
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_movebuddy(aim_session_t *sess, aim_conn_t *conn, const char *oldgn, const char *newgn, const char *sn)
-{
-	struct aim_ssi_item **groups, *buddy, *cur;
-	fu16_t i;
-
-	if (!sess || !conn || !oldgn || !newgn || !sn)
-		return -EINVAL;
-
-	/* Look up the buddy */
-	if (!(buddy = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, sn, AIM_SSI_TYPE_BUDDY)))
-		return -ENOMEM;
-
-	/* Allocate an array of pointers to the two groups */
-	if (!(groups = (struct aim_ssi_item **)malloc(2*sizeof(struct aim_ssi_item *))))
-		return -ENOMEM;
-
-	/* Look up the old parent group */
-	if (!(groups[0] = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, oldgn, AIM_SSI_TYPE_GROUP))) {
-		free(groups);
-		return -ENOMEM;
-	}
-
-	/* Look up the new parent group */
-	if (!(groups[1] = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, newgn, AIM_SSI_TYPE_GROUP))) {
-		aim_ssi_addgroups(sess, conn, (const char**)&newgn, 1);
-		if (!(groups[1] = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, newgn, AIM_SSI_TYPE_GROUP))) {
-			free(groups);
-			return -ENOMEM;
-		}
-	}
-
-	/* Send the delete item SNAC */
-	aim_ssi_addmoddel(sess, conn, &buddy, 1, AIM_CB_SSI_DEL);
-
-	/* Put the buddy in the new group */
-	buddy->gid = groups[1]->gid;
-
-	/* Assign a new buddy ID#, because the new group might already have a buddy with this ID# */
-	buddy->bid = 0;
-	do {
-		buddy->bid += 0x0001;
-		for (cur=sess->ssi.items, i=0; ((cur) && (!i)); cur=cur->next)
-			if ((cur->bid == buddy->bid) && (cur->gid == buddy->gid) && (cur->type == AIM_SSI_TYPE_BUDDY) && (cur->name) && aim_sncmp(cur->name, buddy->name))
-				i=1;
-	} while (i);
-
-	/* Rebuild the additional data in the two parent groups */
-	aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, groups[0]);
-	aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, groups[1]);
-
-	/* Send the add item SNAC */
-	aim_ssi_addmoddel(sess, conn, &buddy, 1, AIM_CB_SSI_ADD);
-
-	/* Send the mod item SNAC */
-	aim_ssi_addmoddel(sess, conn, groups, 2, AIM_CB_SSI_MOD);
-
-	/* Free the temporary array */
-	free(groups);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Rename a group.  I really like how this is done.  It turns me on.
- *
- * Did I say that out loud?...
+faim_export int aim_ssi_movebuddy(aim_session_t *sess, const char *oldgn, const char *newgn, const char *sn)
+{
+	aim_ssi_addbuddy(sess, sn, newgn, aim_ssi_getalias(sess->ssi.local, oldgn, sn), NULL, NULL, aim_ssi_waitingforauth(sess->ssi.local, oldgn, sn));
+	aim_ssi_delbuddy(sess, sn, oldgn);
+	return 0;
+}
+
+/**
+ * Change the alias stored on the server for a given buddy.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
+ * @param gn The group that the buddy is currently in.
+ * @param sn The screen name of the buddy.
+ * @param alias The new alias for the buddy.
+ * @return Return 0 if no errors, otherwise return the error number.
+ */
+faim_export int aim_ssi_aliasbuddy(aim_session_t *sess, const char *gn, const char *sn, const char *alias)
+{
+	struct aim_ssi_item *tmp;
+	aim_tlvlist_t *data = NULL;
+
+	if (!sess || !gn || !sn)
+		return -EINVAL;
+
+	if (!(tmp = aim_ssi_itemlist_finditem(sess->ssi.local, gn, sn, AIM_SSI_TYPE_BUDDY)))
+		return -EINVAL;
+
+	if (alias && !strlen(alias))
+		alias = NULL;
+
+	/* Need to add the x0131 TLV to the TLV chain */
+	if (alias)
+		aim_addtlvtochain_raw(&data, 0x0131, strlen(alias), alias);
+
+	aim_freetlvchain(&tmp->data);
+	tmp->data = data;
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Rename a group.
+ *
+ * @param sess The oscar session.
  * @param oldgn The old group name.
  * @param newgn The new group name.
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_rename_group(aim_session_t *sess, aim_conn_t *conn, const char *oldgn, const char *newgn)
+faim_export int aim_ssi_rename_group(aim_session_t *sess, const char *oldgn, const char *newgn)
 {
 	struct aim_ssi_item *group;
 
-	if (!sess || !conn || !oldgn || !newgn)
-		return -EINVAL;
-
-	/* Look up the group */
-	if (!(group = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, oldgn, AIM_SSI_TYPE_GROUP)))
-		return -ENOMEM;
-
-	/* Free the old group name and copy the new one in its place. */
-	if (group->name)
-		free(group->name);
-	if (!(group->name = (char *)malloc((strlen(newgn)+1)*sizeof(char)))) {
-		group->name = NULL;
-		return -ENOMEM;
-	}
+	if (!sess || !oldgn || !newgn)
+		return -EINVAL;
+
+	if (!(group = aim_ssi_itemlist_finditem(sess->ssi.local, oldgn, NULL, AIM_SSI_TYPE_GROUP)))
+		return -EINVAL;
+
+	free(group->name);
+	group->name = (char *)malloc((strlen(newgn)+1)*sizeof(char));
 	strcpy(group->name, newgn);
 
-	/* Send the mod item SNAC */
-	aim_ssi_addmoddel(sess, conn, &group, 1, AIM_CB_SSI_MOD);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Delete an array of screen names from the given group.
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Stores your permit/deny setting on the server, and starts using it.
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param gn The name of the group from which you want to delete these names.
- * @param sn An array of null terminated strings of the names you want to delete.
- * @param num The number of screen names you are deleting (size of the sn array).
- * @return Return 0 if no errors, otherwise return the error number.
- */
-faim_export int aim_ssi_delbuddies(aim_session_t *sess, aim_conn_t *conn, const char *gn, char **sn, unsigned int num)
-{
-	struct aim_ssi_item *cur, *parentgroup, **delitems;
-	int i;
-
-	if (!sess || !conn || !gn || !sn || !num)
-		return -EINVAL;
-
-	/* Look up the parent group */
-	if (!(parentgroup = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, gn, AIM_SSI_TYPE_GROUP)))
-		return -EINVAL;
-
-	/* Allocate an array of pointers to each of the items to be deleted */
-	delitems = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *));
-	memset(delitems, 0, num*sizeof(struct aim_ssi_item *));
-
-	/* Make the delitems array a pointer to the aim_ssi_item structs to be deleted */
-	for (i=0; i<num; i++) {
-		if (!(delitems[i] = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, sn[i], AIM_SSI_TYPE_BUDDY))) {
-			free(delitems);
-			return -EINVAL;
-		}
-
-		/* Remove the delitems from the item list */
-		if (sess->ssi.items == delitems[i]) {
-			sess->ssi.items = sess->ssi.items->next;
-		} else {
-			for (cur=sess->ssi.items; (cur->next && (cur->next!=delitems[i])); cur=cur->next);
-			if (cur->next)
-				cur->next = cur->next->next;
-		}
-	}
-
-	/* Send the del item SNAC */
-	aim_ssi_addmoddel(sess, conn, delitems, num, AIM_CB_SSI_DEL);
-
-	/* Free the items */
-	for (i=0; i<num; i++) {
-		if (delitems[i]->name)
-			free(delitems[i]->name);
-		if (delitems[i]->data)
-			aim_freetlvchain((aim_tlvlist_t **)&delitems[i]->data);
-		free(delitems[i]);
-	}
-	free(delitems);
-
-	/* Rebuild the additional data in the parent group */
-	aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, parentgroup);
-
-	/* Send the mod item SNAC */
-	aim_ssi_addmoddel(sess, conn, &parentgroup, 1, AIM_CB_SSI_MOD);
-
-	/* Delete the group, but only if it's empty */
-	if (!parentgroup->data)
-		aim_ssi_delgroups(sess, conn, &parentgroup->name, 1);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Delete the master group from the item list.  There can be only one.
- * Er, so just find the one master group and delete it.
- *
- * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @return Return 0 if no errors, otherwise return the error number.
- */
-faim_export int aim_ssi_delmastergroup(aim_session_t *sess, aim_conn_t *conn)
-{
-	struct aim_ssi_item *cur, *delitem;
-
-	if (!sess || !conn)
-		return -EINVAL;
-
-	/* Make delitem a pointer to the aim_ssi_item to be deleted */
-	if (!(delitem = aim_ssi_itemlist_find(sess->ssi.items, 0, 0)))
-		return -EINVAL;
-
-	/* Remove delitem from the item list */
-	if (sess->ssi.items == delitem) {
-		sess->ssi.items = sess->ssi.items->next;
-	} else {
-		for (cur=sess->ssi.items; (cur->next && (cur->next!=delitem)); cur=cur->next);
-		if (cur->next)
-			cur->next = cur->next->next;
-	}
-
-	/* Send the del item SNAC */
-	aim_ssi_addmoddel(sess, conn, &delitem, 1, AIM_CB_SSI_DEL);
-
-	/* Free the item */
-	if (delitem->name)
-		free(delitem->name);
-	if (delitem->data)
-		aim_freetlvchain((aim_tlvlist_t **)&delitem->data);
-	free(delitem);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Delete an array of groups.
- *
- * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param gn An array of null terminated strings of the groups you want to delete.
- * @param num The number of groups you are deleting (size of the gn array).
- * @return Return 0 if no errors, otherwise return the error number.
- */
-faim_export int aim_ssi_delgroups(aim_session_t *sess, aim_conn_t *conn, char **gn, unsigned int num) {
-	struct aim_ssi_item *cur, *parentgroup, **delitems;
-	int i;
-
-	if (!sess || !conn || !gn || !num)
-		return -EINVAL;
-
-	/* Look up the parent group */
-	if (!(parentgroup = aim_ssi_itemlist_find(sess->ssi.items, 0, 0)))
-		return -EINVAL;
-
-	/* Allocate an array of pointers to each of the items to be deleted */
-	delitems = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *));
-	memset(delitems, 0, num*sizeof(struct aim_ssi_item *));
-
-	/* Make the delitems array a pointer to the aim_ssi_item structs to be deleted */
-	for (i=0; i<num; i++) {
-		if (!(delitems[i] = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, gn[i], AIM_SSI_TYPE_GROUP))) {
-			free(delitems);
-			return -EINVAL;
-		}
-
-		/* Remove the delitems from the item list */
-		if (sess->ssi.items == delitems[i]) {
-			sess->ssi.items = sess->ssi.items->next;
-		} else {
-			for (cur=sess->ssi.items; (cur->next && (cur->next!=delitems[i])); cur=cur->next);
-			if (cur->next)
-				cur->next = cur->next->next;
-		}
-	}
-
-	/* Send the del item SNAC */
-	aim_ssi_addmoddel(sess, conn, delitems, num, AIM_CB_SSI_DEL);
-
-	/* Free the items */
-	for (i=0; i<num; i++) {
-		if (delitems[i]->name)
-			free(delitems[i]->name);
-		if (delitems[i]->data)
-			aim_freetlvchain((aim_tlvlist_t **)&delitems[i]->data);
-		free(delitems[i]);
-	}
-	free(delitems);
-
-	/* Rebuild the additional data in the parent group */
-	aim_ssi_itemlist_rebuildgroup(&sess->ssi.items, parentgroup);
-
-	/* Send the mod item SNAC */
-	aim_ssi_addmoddel(sess, conn, &parentgroup, 1, AIM_CB_SSI_MOD);
-
-	/* Delete the group, but only if it's empty */
-	if (!parentgroup->data)
-		aim_ssi_delmastergroup(sess, conn);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Delete an array of a certain type of item from the list.  This can be 
- * used for permit buddies, deny buddies, ICQ's ignore buddies, and 
- * probably other types, also.
- *
- * @param sess The oscar session.
- * @param conn The bos connection for this session.
- * @param sn An array of null terminated strings of the items you want to delete.
- * @param num The number of items you are deleting (size of the sn array).
- * @return Return 0 if no errors, otherwise return the error number.
- */
-faim_export int aim_ssi_delpord(aim_session_t *sess, aim_conn_t *conn, const char **sn, unsigned int num, fu16_t type) {
-	struct aim_ssi_item *cur, **delitems;
-	int i;
-
-	if (!sess || !conn || !sn || !num || (type!=AIM_SSI_TYPE_PERMIT && type!=AIM_SSI_TYPE_DENY))
-		return -EINVAL;
-
-	/* Allocate an array of pointers to each of the items to be deleted */
-	delitems = (struct aim_ssi_item **)malloc(num*sizeof(struct aim_ssi_item *));
-	memset(delitems, 0, num*sizeof(struct aim_ssi_item *));
-
-	/* Make the delitems array a pointer to the aim_ssi_item structs to be deleted */
-	for (i=0; i<num; i++) {
-		if (!(delitems[i] = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, sn[i], type))) {
-			free(delitems);
-			return -EINVAL;
-		}
-
-		/* Remove the delitems from the item list */
-		if (sess->ssi.items == delitems[i]) {
-			sess->ssi.items = sess->ssi.items->next;
-		} else {
-			for (cur=sess->ssi.items; (cur->next && (cur->next!=delitems[i])); cur=cur->next);
-			if (cur->next)
-				cur->next = cur->next->next;
-		}
-	}
-
-	/* Send the del item SNAC */
-	aim_ssi_addmoddel(sess, conn, delitems, num, AIM_CB_SSI_DEL);
-
-	/* Free the items */
-	for (i=0; i<num; i++) {
-		if (delitems[i]->name)
-			free(delitems[i]->name);
-		if (delitems[i]->data)
-			aim_freetlvchain((aim_tlvlist_t **)&delitems[i]->data);
-		free(delitems[i]);
-	}
-	free(delitems);
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/**
- * Stores your permit/deny setting on the server, and starts using it.
- *
- * @param sess The oscar session.
- * @param conn The bos connection for this session.
  * @param permdeny Your permit/deny setting.  Can be one of the following:
  *        1 - Allow all users
@@ -1055,56 +971,79 @@
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_setpermdeny(aim_session_t *sess, aim_conn_t *conn, fu8_t permdeny, fu32_t vismask) {
-	struct aim_ssi_item *cur;
-	aim_tlv_t *tlv;
-
-	if (!sess || !conn)
-		return -EINVAL;
-
-	/* Look up the permit/deny settings item */
-	cur = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, NULL, AIM_SSI_TYPE_PDINFO);
-
-	if (cur) {
-		/* The permit/deny item exists */
-		if (cur->data && (tlv = aim_gettlv(cur->data, 0x00ca, 1))) {
-			/* Just change the value of the x00ca TLV */
-			if (tlv->length != 1) {
-				tlv->length = 1;
-				free(tlv->value);
-				tlv->value = (fu8_t *)malloc(sizeof(fu8_t));
-			}
-			tlv->value[0] = permdeny;
-		} else {
-			/* Need to add the x00ca TLV to the TLV chain */
-			aim_addtlvtochain8((aim_tlvlist_t**)&cur->data, 0x00ca, permdeny);
+faim_export int aim_ssi_setpermdeny(aim_session_t *sess, fu8_t permdeny, fu32_t vismask)
+{
+	struct aim_ssi_item *tmp;
+	aim_tlvlist_t *data = NULL;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Need to add the x00ca TLV to the TLV chain */
+	aim_addtlvtochain8(&data, 0x00ca, permdeny);
+
+	/* Need to add the x00cb TLV to the TLV chain */
+	aim_addtlvtochain32(&data, 0x00cb, vismask);
+
+	if ((tmp = aim_ssi_itemlist_finditem(sess->ssi.local, NULL, NULL, AIM_SSI_TYPE_PDINFO))) {
+		aim_freetlvchain(&tmp->data);
+		tmp->data = data;
+	} else {
+		tmp = aim_ssi_itemlist_add(&sess->ssi.local, NULL, 0x0000, 0xFFFF, AIM_SSI_TYPE_PDINFO, data);
+		aim_freetlvchain(&data);
+	}
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/**
+ * Set buddy icon information
+ *
+ * @param sess The oscar session.
+ * @param iconcsum The MD5 checksum of the icon you are using.
+ * @param iconcsumlen Length of the MD5 checksum given above.  Should be 0x10 bytes.
+ * @return Return 0 if no errors, otherwise return the error number.
+ */
+faim_export int aim_ssi_seticon(aim_session_t *sess, fu8_t *iconsum, fu16_t iconsumlen)
+{
+	struct aim_ssi_item *tmp;
+	aim_tlvlist_t *data = NULL;
+	fu8_t *csumdata;
+
+	if (!sess || !iconsum || !iconsumlen)
+		return -EINVAL;
+
+	if (!(csumdata = (fu8_t *)malloc((iconsumlen+2)*sizeof(fu8_t))))
+		return -ENOMEM;
+	csumdata[0] = 0x00;
+	csumdata[1] = 0x10;
+	memcpy(&csumdata[2], iconsum, iconsumlen);
+
+	/* Need to add the x00d5 TLV to the TLV chain */
+	aim_addtlvtochain_raw(&data, 0x00d5, (iconsumlen+2) * sizeof(fu8_t), csumdata);
+
+	/* This TLV is added to cache the icon. */
+	aim_addtlvtochain_noval(&data, 0x0131);
+
+	if ((tmp = aim_ssi_itemlist_finditem(sess->ssi.local, NULL, "1", AIM_SSI_TYPE_ICONINFO))) {
+		/* If the new tlvchain and oldtlvchain are the same, then do nothing */
+		if (!aim_tlvlist_cmp(tmp->data, data)) {
+			/* The new tlvlist is the identical to the old one */
+			aim_freetlvchain(&data);
+			free(csumdata);
+			return 0;
 		}
-
-		if (cur->data && (tlv = aim_gettlv(cur->data, 0x00cb, 1))) {
-			/* Just change the value of the x00cb TLV */
-			if (tlv->length != 4) {
-				tlv->length = 4;
-				free(tlv->value);
-				tlv->value = (fu8_t *)malloc(4*sizeof(fu8_t));
-			}
-			aimutil_put32(tlv->value, vismask);
-		} else {
-			/* Need to add the x00cb TLV to the TLV chain */
-			aim_addtlvtochain32((aim_tlvlist_t**)&cur->data, 0x00cb, vismask);
-		}
-
-		/* Send the mod item SNAC */
-		aim_ssi_addmoddel(sess, conn, &cur, 1, AIM_CB_SSI_MOD);
+		aim_freetlvchain(&tmp->data);
+		tmp->data = data;
 	} else {
-		/* Need to add the permit/deny item */
-		if (!(cur = aim_ssi_itemlist_add(&sess->ssi.items, NULL, NULL, AIM_SSI_TYPE_PDINFO)))
-			return -ENOMEM;
-		aim_addtlvtochain8((aim_tlvlist_t**)&cur->data, 0x00ca, permdeny);
-		aim_addtlvtochain32((aim_tlvlist_t**)&cur->data, 0x00cb, vismask);
-		aim_ssi_addmoddel(sess, conn, &cur, 1, AIM_CB_SSI_ADD);
-	}
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
+		tmp = aim_ssi_itemlist_add(&sess->ssi.local, "1", 0x0000, 0x51F4, AIM_SSI_TYPE_ICONINFO, data);
+		aim_freetlvchain(&data);
+	}
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+	free(csumdata);
 	return 0;
 }
@@ -1114,68 +1053,81 @@
  *
  * @param sess The oscar session.
- * @param conn The bos connection for this session.
  * @param presence I think it's a bitmask, but I only know what one of the bits is:
  *        0x00000400 - Allow others to see your idle time
  * @return Return 0 if no errors, otherwise return the error number.
  */
-faim_export int aim_ssi_setpresence(aim_session_t *sess, aim_conn_t *conn, fu32_t presence) {
-	struct aim_ssi_item *cur;
+faim_export int aim_ssi_setpresence(aim_session_t *sess, fu32_t presence) {
+	struct aim_ssi_item *tmp;
+	aim_tlvlist_t *data = NULL;
+
+	if (!sess)
+		return -EINVAL;
+
+	/* Need to add the x00c9 TLV to the TLV chain */
+	aim_addtlvtochain32(&data, 0x00c9, presence);
+
+	if ((tmp = aim_ssi_itemlist_finditem(sess->ssi.local, NULL, NULL, AIM_SSI_TYPE_PRESENCEPREFS))) {
+		aim_freetlvchain(&tmp->data);
+		tmp->data = data;
+	} else {
+		tmp = aim_ssi_itemlist_add(&sess->ssi.local, NULL, 0x0000, 0xFFFF, AIM_SSI_TYPE_PRESENCEPREFS, data);
+		aim_freetlvchain(&data);
+	}
+
+	/* Sync our local list with the server list */
+	aim_ssi_sync(sess);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x0002 - Request SSI Rights.
+ */
+faim_export int aim_ssi_reqrights(aim_session_t *sess)
+{
+	aim_conn_t *conn;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)))
+		return -EINVAL;
+
+	return aim_genericreq_n(sess, conn, AIM_CB_FAM_SSI, AIM_CB_SSI_REQRIGHTS);
+}
+
+/*
+ * Subtype 0x0003 - SSI Rights Information.
+ */
+static int parserights(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0, i;
+	aim_rxcallback_t userfunc;
+	aim_tlvlist_t *tlvlist;
 	aim_tlv_t *tlv;
-
-	if (!sess || !conn)
-		return -EINVAL;
-
-	/* Look up the item */
-	cur = aim_ssi_itemlist_finditem(sess->ssi.items, NULL, NULL, AIM_SSI_TYPE_PRESENCEPREFS);
-
-	if (cur) {
-		/* The item exists */
-		if (cur->data && (tlv = aim_gettlv(cur->data, 0x00c9, 1))) {
-			/* Just change the value of the x00c9 TLV */
-			if (tlv->length != 4) {
-				tlv->length = 4;
-				free(tlv->value);
-				tlv->value = (fu8_t *)malloc(4*sizeof(fu8_t));
-			}
-			aimutil_put32(tlv->value, presence);
-		} else {
-			/* Need to add the x00c9 TLV to the TLV chain */
-			aim_addtlvtochain32((aim_tlvlist_t**)&cur->data, 0x00c9, presence);
-		}
-
-		/* Send the mod item SNAC */
-		aim_ssi_addmoddel(sess, conn, &cur, 1, AIM_CB_SSI_MOD);
-	} else {
-		/* Need to add the item */
-		if (!(cur = aim_ssi_itemlist_add(&sess->ssi.items, NULL, NULL, AIM_SSI_TYPE_PRESENCEPREFS)))
-			return -ENOMEM;
-		aim_addtlvtochain32((aim_tlvlist_t**)&cur->data, 0x00c9, presence);
-		aim_ssi_addmoddel(sess, conn, &cur, 1, AIM_CB_SSI_ADD);
-	}
-
-	/* Begin sending SSI SNACs */
-	aim_ssi_dispatch(sess, conn);
-
-	return 0;
-}
-
-/*
- * Request SSI Rights.
- */
-faim_export int aim_ssi_reqrights(aim_session_t *sess, aim_conn_t *conn)
-{
-	return aim_genericreq_n(sess, conn, AIM_CB_FAM_SSI, AIM_CB_SSI_REQRIGHTS);
-}
-
-/*
- * SSI Rights Information.
- */
-static int parserights(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
-{
-	int ret = 0;
-	aim_rxcallback_t userfunc;
+	aim_bstream_t bstream;
+	fu16_t *maxitems;
+
+	/* This SNAC is made up of a bunch of TLVs */
+	tlvlist = aim_readtlvchain(bs);
+
+	/* TLV 0x0004 contains the maximum number of each item */
+	if (!(tlv = aim_gettlv(tlvlist, 0x0004, 1))) {
+		aim_freetlvchain(&tlvlist);
+		return 0;
+	}
+
+	aim_bstream_init(&bstream, tlv->value, tlv->length);
+
+	if (!(maxitems = (fu16_t *)malloc((tlv->length/2)*sizeof(fu16_t)))) {
+		aim_freetlvchain(&tlvlist);
+		return 0;
+	}
+
+	for (i=0; i<(tlv->length/2); i++)
+		maxitems[i] = aimbs_get16(&bstream);
 
 	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
-		ret = userfunc(sess, rx);
+		ret = userfunc(sess, rx, tlv->length/2, maxitems);
+
+	aim_freetlvchain(&tlvlist);
+	free(maxitems);
 
 	return ret;
@@ -1183,5 +1135,24 @@
 
 /*
- * Request SSI Data.
+ * Subtype 0x0004 - Request SSI Data when you don't have a timestamp and 
+ * revision number.
+ * 
+ */
+faim_export int aim_ssi_reqdata(aim_session_t *sess)
+{
+	aim_conn_t *conn;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)))
+		return -EINVAL;
+
+	/* Free any current data, just in case */
+	aim_ssi_freelist(sess);
+
+	return aim_genericreq_n_snacid(sess, conn, AIM_CB_FAM_SSI, AIM_CB_SSI_REQDATA);
+}
+
+/*
+ * Subtype 0x0005 - Request SSI Data when you have a timestamp and revision 
+ * number.
  *
  * The data will only be sent if it is newer than the posted local
@@ -1191,10 +1162,11 @@
  * 
  */
-faim_export int aim_ssi_reqdata(aim_session_t *sess, aim_conn_t *conn, time_t localstamp, fu16_t localrev)
-{
+faim_export int aim_ssi_reqifchanged(aim_session_t *sess, time_t timestamp, fu16_t numitems)
+{
+	aim_conn_t *conn;
 	aim_frame_t *fr;
 	aim_snacid_t snacid;
 
-	if (!sess || !conn)
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)))
 		return -EINVAL;
 
@@ -1202,17 +1174,20 @@
 		return -ENOMEM;
 
-	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, AIM_CB_SSI_REQLIST, 0x0000, NULL, 0);
-
-	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, AIM_CB_SSI_REQLIST, 0x0000, snacid);
-	aimbs_put32(&fr->data, localstamp);
-	aimbs_put16(&fr->data, localrev);
+	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, AIM_CB_SSI_REQIFCHANGED, 0x0000, NULL, 0);
+
+	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, AIM_CB_SSI_REQIFCHANGED, 0x0000, snacid);
+	aimbs_put32(&fr->data, timestamp);
+	aimbs_put16(&fr->data, numitems);
 
 	aim_tx_enqueue(sess, fr);
 
-	return 0;
-}
-
-/*
- * SSI Data.
+	/* Free any current data, just in case */
+	aim_ssi_freelist(sess);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x0006 - SSI Data.
  */
 static int parsedata(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
@@ -1220,60 +1195,41 @@
 	int ret = 0;
 	aim_rxcallback_t userfunc;
-	struct aim_ssi_item *cur = NULL;
 	fu8_t fmtver; /* guess */
-	fu16_t revision;
-	fu32_t timestamp;
-
-	/* When you set the version for the SSI family to 2-4, the beginning of this changes.
-	 * Instead of the version and then the revision, there is "0x0006" and then a type 
-	 * 0x0001 TLV containing the 2 byte SSI family version that you sent earlier.  Also, 
-	 * the SNAC flags go from 0x0000 to 0x8000.  I guess the 0x0006 is the length of the 
-	 * TLV(s) that follow.  The rights SNAC does the same thing, with the differing flag 
-	 * and everything.
-	 */
+	fu16_t namelen, gid, bid, type;
+	char *name;
+	aim_tlvlist_t *data;
 
 	fmtver = aimbs_get8(bs); /* Version of ssi data.  Should be 0x00 */
-	revision = aimbs_get16(bs); /* # of times ssi data has been modified */
-	if (revision != 0)
-		sess->ssi.revision = revision;
-
-	for (cur = sess->ssi.items; cur && cur->next; cur=cur->next) ;
-
-	while (aim_bstream_empty(bs) > 4) { /* last four bytes are stamp */
-		fu16_t namelen, tbslen;
-
-		if (!sess->ssi.items) {
-			if (!(sess->ssi.items = malloc(sizeof(struct aim_ssi_item))))
-				return -ENOMEM;
-			cur = sess->ssi.items;
-		} else {
-			if (!(cur->next = malloc(sizeof(struct aim_ssi_item))))
-				return -ENOMEM;
-			cur = cur->next;
-		}
-		memset(cur, 0, sizeof(struct aim_ssi_item));
-
+	sess->ssi.numitems += aimbs_get16(bs); /* # of items in this SSI SNAC */
+
+	/* Read in the list */
+	while (aim_bstream_empty(bs) > 4) { /* last four bytes are timestamp */
 		if ((namelen = aimbs_get16(bs)))
-			cur->name = aimbs_getstr(bs, namelen);
-		cur->gid = aimbs_get16(bs);
-		cur->bid = aimbs_get16(bs);
-		cur->type = aimbs_get16(bs);
-
-		if ((tbslen = aimbs_get16(bs))) {
-			aim_bstream_t tbs;
-
-			aim_bstream_init(&tbs, bs->data + bs->offset /* XXX */, tbslen);
-			cur->data = (void *)aim_readtlvchain(&tbs);
-			aim_bstream_advance(bs, tbslen);
-		}
-	}
-
-	timestamp = aimbs_get32(bs);
-	if (timestamp != 0)
-		sess->ssi.timestamp = timestamp;
-	sess->ssi.received_data = 1;
-
-	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
-		ret = userfunc(sess, rx, fmtver, sess->ssi.revision, sess->ssi.timestamp, sess->ssi.items);
+			name = aimbs_getstr(bs, namelen);
+		else
+			name = NULL;
+		gid = aimbs_get16(bs);
+		bid = aimbs_get16(bs);
+		type = aimbs_get16(bs);
+		data = aim_readtlvchain_len(bs, aimbs_get16(bs));
+		aim_ssi_itemlist_add(&sess->ssi.official, name, gid, bid, type, data);
+		free(name);
+		aim_freetlvchain(&data);
+	}
+
+	/* Read in the timestamp */
+	sess->ssi.timestamp = aimbs_get32(bs);
+
+	if (!(snac->flags & 0x0001)) {
+		/* Make a copy of the list */
+		struct aim_ssi_item *cur;
+		for (cur=sess->ssi.official; cur; cur=cur->next)
+			aim_ssi_itemlist_add(&sess->ssi.local, cur->name, cur->gid, cur->bid, cur->type, cur->data);
+
+		sess->ssi.received_data = 1;
+
+		if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+			ret = userfunc(sess, rx, fmtver, sess->ssi.numitems, sess->ssi.official, sess->ssi.timestamp);
+	}
 
 	return ret;
@@ -1281,5 +1237,5 @@
 
 /*
- * SSI Data Enable Presence.
+ * Subtype 0x0007 - SSI Activate Data.
  *
  * Should be sent after receiving 13/6 or 13/f to tell the server you
@@ -1289,11 +1245,16 @@
  * 
  */
-faim_export int aim_ssi_enable(aim_session_t *sess, aim_conn_t *conn)
-{
+faim_export int aim_ssi_enable(aim_session_t *sess)
+{
+	aim_conn_t *conn;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)))
+		return -EINVAL;
+
 	return aim_genericreq_n(sess, conn, AIM_CB_FAM_SSI, 0x0007);
 }
 
 /*
- * SSI Add/Mod/Del Item(s).
+ * Subtype 0x0008/0x0009/0x000a - SSI Add/Mod/Del Item(s).
  *
  * Sends the SNAC to add, modify, or delete an item from the server-stored
@@ -1302,20 +1263,23 @@
  * 
  */
-faim_export int aim_ssi_addmoddel(aim_session_t *sess, aim_conn_t *conn, struct aim_ssi_item **items, unsigned int num, fu16_t subtype)
-{
+faim_export int aim_ssi_addmoddel(aim_session_t *sess)
+{
+	aim_conn_t *conn;
 	aim_frame_t *fr;
 	aim_snacid_t snacid;
-	int i, snaclen;
-
-	if (!sess || !conn || !items || !num)
-		return -EINVAL;
-
+	int snaclen;
+	struct aim_ssi_tmp *cur;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)) || !sess->ssi.pending || !sess->ssi.pending->item)
+		return -EINVAL;
+
+	/* Calculate total SNAC size */
 	snaclen = 10; /* For family, subtype, flags, and SNAC ID */
-	for (i=0; i<num; i++) {
+	for (cur=sess->ssi.pending; cur; cur=cur->next) {
 		snaclen += 10; /* For length, GID, BID, type, and length */
-		if (items[i]->name)
-			snaclen += strlen(items[i]->name);
-		if (items[i]->data)
-			snaclen += aim_sizetlvchain((aim_tlvlist_t **)&items[i]->data);
+		if (cur->item->name)
+			snaclen += strlen(cur->item->name);
+		if (cur->item->data)
+			snaclen += aim_sizetlvchain(&cur->item->data);
 	}
 
@@ -1323,37 +1287,295 @@
 		return -ENOMEM;
 
-	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, subtype, 0x0000, NULL, 0);
-	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, subtype, 0x0000, snacid);
-
-	for (i=0; i<num; i++) {
-		aimbs_put16(&fr->data, items[i]->name ? strlen(items[i]->name) : 0);
-		if (items[i]->name)
-			aimbs_putraw(&fr->data, items[i]->name, strlen(items[i]->name));
-		aimbs_put16(&fr->data, items[i]->gid);
-		aimbs_put16(&fr->data, items[i]->bid);
-		aimbs_put16(&fr->data, items[i]->type);
-		aimbs_put16(&fr->data, items[i]->data ? aim_sizetlvchain((aim_tlvlist_t **)&items[i]->data) : 0);
-		if (items[i]->data)
-			aim_writetlvchain(&fr->data, (aim_tlvlist_t **)&items[i]->data);
-	}
-
-	aim_ssi_enqueue(sess, conn, fr);
-
-	return 0;
-}
-
-/*
- * SSI Add/Mod/Del Ack.
- *
- * Response to add, modify, or delete SNAC (sent with aim_ssi_addmoddel).
- *
- */
-static int parseack(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, sess->ssi.pending->action, 0x0000, NULL, 0);
+	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, sess->ssi.pending->action, 0x0000, snacid);
+
+	for (cur=sess->ssi.pending; cur; cur=cur->next) {
+		aimbs_put16(&fr->data, cur->item->name ? strlen(cur->item->name) : 0);
+		if (cur->item->name)
+			aimbs_putraw(&fr->data, cur->item->name, strlen(cur->item->name));
+		aimbs_put16(&fr->data, cur->item->gid);
+		aimbs_put16(&fr->data, cur->item->bid);
+		aimbs_put16(&fr->data, cur->item->type);
+		aimbs_put16(&fr->data, cur->item->data ? aim_sizetlvchain(&cur->item->data) : 0);
+		if (cur->item->data)
+			aim_writetlvchain(&fr->data, &cur->item->data);
+	}
+
+	aim_tx_enqueue(sess, fr);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x0008 - Incoming SSI add.
+ *
+ * XXX - It would probably be good for the client to actually do something when it gets this.
+ */
+static int parseadd(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
 {
 	int ret = 0;
 	aim_rxcallback_t userfunc;
-
-	sess->ssi.waiting_for_ack = 0;
-	aim_ssi_dispatch(sess, rx->conn);
+	char *name;
+	fu16_t len, gid, bid, type;
+	aim_tlvlist_t *data;
+
+	while (aim_bstream_empty(bs)) {
+		if ((len = aimbs_get16(bs)))
+			name = aimbs_getstr(bs, len);
+		else
+			name = NULL;
+		gid = aimbs_get16(bs);
+		bid = aimbs_get16(bs);
+		type = aimbs_get16(bs);
+		if ((len = aimbs_get16(bs)))
+			data = aim_readtlvchain_len(bs, len);
+		else
+			data = NULL;
+
+		aim_ssi_itemlist_add(&sess->ssi.local, name, gid, bid, type, data);
+		aim_ssi_itemlist_add(&sess->ssi.official, name, gid, bid, type, data);
+		free(name);
+		aim_freetlvchain(&data);
+
+		if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+			ret = userfunc(sess, rx);
+
+		free(name);
+	}
+
+	return ret;
+}
+
+/*
+ * Subtype 0x0009 - Incoming SSI mod.
+ *
+ * XXX - It would probably be good for the client to actually do something when it gets this.
+ */
+static int parsemod(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	char *name;
+	fu16_t len, gid, bid, type;
+	aim_tlvlist_t *data;
+	struct aim_ssi_item *item;
+
+	while (aim_bstream_empty(bs)) {
+		if ((len = aimbs_get16(bs)))
+			name = aimbs_getstr(bs, len);
+		else
+			name = NULL;
+		gid = aimbs_get16(bs);
+		bid = aimbs_get16(bs);
+		type = aimbs_get16(bs);
+		if ((len = aimbs_get16(bs)))
+			data = aim_readtlvchain_len(bs, len);
+		else
+			data = NULL;
+
+		/* Replace the 2 local items with the given one */
+		if ((item = aim_ssi_itemlist_find(sess->ssi.local, gid, bid))) {
+			item->type = type;
+			free(item->name);
+			if (name) {
+				item->name = (char *)malloc((strlen(name)+1)*sizeof(char));
+				strcpy(item->name, name);
+			} else
+				item->name = NULL;
+			aim_freetlvchain(&item->data);
+			item->data = aim_tlvlist_copy(data);
+		}
+
+		if ((item = aim_ssi_itemlist_find(sess->ssi.official, gid, bid))) {
+			item->type = type;
+			free(item->name);
+			if (name) {
+				item->name = (char *)malloc((strlen(name)+1)*sizeof(char));
+				strcpy(item->name, name);
+			} else
+				item->name = NULL;
+			aim_freetlvchain(&item->data);
+			item->data = aim_tlvlist_copy(data);
+		}
+
+		if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+			ret = userfunc(sess, rx);
+
+		free(name);
+		aim_freetlvchain(&data);
+	}
+
+	return ret;
+}
+
+/*
+ * Subtype 0x000a - Incoming SSI del.
+ *
+ * XXX - It would probably be good for the client to actually do something when it gets this.
+ */
+static int parsedel(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	fu16_t gid, bid;
+	struct aim_ssi_item *del;
+
+	while (aim_bstream_empty(bs)) {
+		aim_bstream_advance(bs, aimbs_get16(bs));
+		gid = aimbs_get16(bs);
+		bid = aimbs_get16(bs);
+		aimbs_get16(bs);
+		aim_bstream_advance(bs, aimbs_get16(bs));
+
+		if ((del = aim_ssi_itemlist_find(sess->ssi.local, gid, bid)))
+			aim_ssi_itemlist_del(&sess->ssi.local, del);
+		if ((del = aim_ssi_itemlist_find(sess->ssi.official, gid, bid)))
+			aim_ssi_itemlist_del(&sess->ssi.official, del);
+
+		if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+			ret = userfunc(sess, rx);
+	}
+
+	return ret;
+}
+
+/*
+ * Subtype 0x000e - SSI Add/Mod/Del Ack.
+ *
+ * Response to add, modify, or delete SNAC (sent with aim_ssi_addmoddel).
+ *
+ */
+static int parseack(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	struct aim_ssi_tmp *cur, *del;
+
+	/* Read in the success/failure flags from the ack SNAC */
+	cur = sess->ssi.pending;
+	while (cur && (aim_bstream_empty(bs)>0)) {
+		cur->ack = aimbs_get16(bs);
+		cur = cur->next;
+	}
+
+	/*
+	 * If outcome is 0, then add the item to the item list, or replace the other item, 
+	 * or remove the old item.  If outcome is non-zero, then remove the item from the 
+	 * local list, or unmodify it, or add it.
+	 */
+	for (cur=sess->ssi.pending; (cur && (cur->ack != 0xffff)); cur=cur->next) {
+	if (cur->item) {
+		if (cur->ack) {
+			/* Our action was unsuccessful, so change the local list back to how it was */
+			if (cur->action == AIM_CB_SSI_ADD) {
+				/* Remove the item from the local list */
+				/* Make sure cur->item is still valid memory */
+				if (aim_ssi_itemlist_valid(sess->ssi.local, cur->item)) {
+					if (cur->item->name) {
+						cur->name = (char *)malloc((strlen(cur->item->name)+1)*sizeof(char));
+						strcpy(cur->name, cur->item->name);
+					}
+					aim_ssi_itemlist_del(&sess->ssi.local, cur->item);
+				}
+				cur->item = NULL;
+
+			} else if (cur->action == AIM_CB_SSI_MOD) {
+				/* Replace the local item with the item from the official list */
+				if (aim_ssi_itemlist_valid(sess->ssi.local, cur->item)) {
+					struct aim_ssi_item *cur1;
+					if ((cur1 = aim_ssi_itemlist_find(sess->ssi.official, cur->item->gid, cur->item->bid))) {
+						free(cur->item->name);
+						if (cur1->name) {
+							cur->item->name = (char *)malloc((strlen(cur1->name)+1)*sizeof(char));
+							strcpy(cur->item->name, cur1->name);
+						} else
+							cur->item->name = NULL;
+						aim_freetlvchain(&cur->item->data);
+						cur->item->data = aim_tlvlist_copy(cur1->data);
+					}
+				} else
+					cur->item = NULL;
+
+			} else if (cur->action == AIM_CB_SSI_DEL) {
+				/* Add the item back into the local list */
+				if (aim_ssi_itemlist_valid(sess->ssi.official, cur->item)) {
+					aim_ssi_itemlist_add(&sess->ssi.local, cur->item->name, cur->item->gid, cur->item->bid, cur->item->type, cur->item->data);
+				} else
+					cur->item = NULL;
+			}
+
+		} else {
+			/* Do the exact opposite */
+			if (cur->action == AIM_CB_SSI_ADD) {
+			/* Add the local item to the official list */
+				if (aim_ssi_itemlist_valid(sess->ssi.local, cur->item)) {
+					aim_ssi_itemlist_add(&sess->ssi.official, cur->item->name, cur->item->gid, cur->item->bid, cur->item->type, cur->item->data);
+				} else
+					cur->item = NULL;
+
+			} else if (cur->action == AIM_CB_SSI_MOD) {
+				/* Replace the official item with the item from the local list */
+				if (aim_ssi_itemlist_valid(sess->ssi.local, cur->item)) {
+					struct aim_ssi_item *cur1;
+					if ((cur1 = aim_ssi_itemlist_find(sess->ssi.official, cur->item->gid, cur->item->bid))) {
+						free(cur1->name);
+						if (cur->item->name) {
+							cur1->name = (char *)malloc((strlen(cur->item->name)+1)*sizeof(char));
+							strcpy(cur1->name, cur->item->name);
+						} else
+							cur1->name = NULL;
+						aim_freetlvchain(&cur1->data);
+						cur1->data = aim_tlvlist_copy(cur->item->data);
+					}
+				} else
+					cur->item = NULL;
+
+			} else if (cur->action == AIM_CB_SSI_DEL) {
+				/* Remove the item from the official list */
+				if (aim_ssi_itemlist_valid(sess->ssi.official, cur->item))
+					aim_ssi_itemlist_del(&sess->ssi.official, cur->item);
+				cur->item = NULL;
+			}
+
+		}
+	} /* End if (cur->item) */
+	} /* End for loop */
+
+	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+		ret = userfunc(sess, rx, sess->ssi.pending);
+
+	/* Free all aim_ssi_tmp's with an outcome */
+	cur = sess->ssi.pending;
+	while (cur && (cur->ack != 0xffff)) {
+		del = cur;
+		cur = cur->next;
+		free(del->name);
+		free(del);
+	}
+	sess->ssi.pending = cur;
+
+	/* If we're not waiting for any more acks, then send more SNACs */
+	if (!sess->ssi.pending) {
+		sess->ssi.pending = NULL;
+		sess->ssi.waiting_for_ack = 0;
+		aim_ssi_sync(sess);
+	}
+
+	return ret;
+}
+
+/*
+ * Subtype 0x000f - SSI Data Unchanged.
+ *
+ * Response to aim_ssi_reqifchanged() if the server-side data is not newer than
+ * posted local stamp/revision.
+ *
+ */
+static int parsedataunchanged(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+
+	sess->ssi.received_data = 1;
 
 	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
@@ -1364,41 +1586,291 @@
 
 /*
- * SSI Begin Data Modification.
+ * Subtype 0x0011 - SSI Begin Data Modification.
  *
  * Tells the server you're going to start modifying data.
  * 
  */
-faim_export int aim_ssi_modbegin(aim_session_t *sess, aim_conn_t *conn)
-{
+faim_export int aim_ssi_modbegin(aim_session_t *sess)
+{
+	aim_conn_t *conn;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)))
+		return -EINVAL;
+
 	return aim_genericreq_n(sess, conn, AIM_CB_FAM_SSI, AIM_CB_SSI_EDITSTART);
 }
 
 /*
- * SSI End Data Modification.
- *
- * Tells the server you're done modifying data.
- *
- */
-faim_export int aim_ssi_modend(aim_session_t *sess, aim_conn_t *conn)
-{
+ * Subtype 0x0012 - SSI End Data Modification.
+ *
+ * Tells the server you're finished modifying data.
+ *
+ */
+faim_export int aim_ssi_modend(aim_session_t *sess)
+{
+	aim_conn_t *conn;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)))
+		return -EINVAL;
+
 	return aim_genericreq_n(sess, conn, AIM_CB_FAM_SSI, AIM_CB_SSI_EDITSTOP);
 }
 
 /*
- * SSI Data Unchanged.
- *
- * Response to aim_ssi_reqdata() if the server-side data is not newer than
- * posted local stamp/revision.
- *
- */
-static int parsedataunchanged(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+ * Subtype 0x0014 - Grant authorization
+ *
+ * Authorizes a contact so they can add you to their contact list.
+ *
+ */
+faim_export int aim_ssi_sendauth(aim_session_t *sess, char *sn, char *msg)
+{
+	aim_conn_t *conn;
+	aim_frame_t *fr;
+	aim_snacid_t snacid;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)) || !sn)
+		return -EINVAL;
+
+	if (!(fr = aim_tx_new(sess, conn, AIM_FRAMETYPE_FLAP, 0x02, 10+1+strlen(sn)+2+(msg ? strlen(msg)+1 : 0)+2)))
+		return -ENOMEM;
+
+	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, AIM_CB_SSI_SENDAUTH, 0x0000, NULL, 0);
+	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, AIM_CB_SSI_SENDAUTH, 0x0000, snacid);
+
+	/* Screen name */
+	aimbs_put8(&fr->data, strlen(sn));
+	aimbs_putraw(&fr->data, sn, strlen(sn));
+
+	/* Message (null terminated) */
+	aimbs_put16(&fr->data, msg ? strlen(msg) : 0);
+	if (msg) {
+		aimbs_putraw(&fr->data, msg, strlen(msg));
+		aimbs_put8(&fr->data, 0x00);
+	}
+
+	/* Unknown */
+	aimbs_put16(&fr->data, 0x0000);
+
+	aim_tx_enqueue(sess, fr);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x0015 - Receive an authorization grant
+ */
+static int receiveauthgrant(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
 {
 	int ret = 0;
 	aim_rxcallback_t userfunc;
-
-	sess->ssi.received_data = 1;
+	fu16_t tmp;
+	char *sn, *msg;
+
+	/* Read screen name */
+	if ((tmp = aimbs_get8(bs)))
+		sn = aimbs_getstr(bs, tmp);
+	else
+		sn = NULL;
+
+	/* Read message (null terminated) */
+	if ((tmp = aimbs_get16(bs)))
+		msg = aimbs_getstr(bs, tmp);
+	else
+		msg = NULL;
+
+	/* Unknown */
+	tmp = aimbs_get16(bs);
 
 	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
-		ret = userfunc(sess, rx);
+		ret = userfunc(sess, rx, sn, msg);
+
+	free(sn);
+	free(msg);
+
+	return ret;
+}
+
+/*
+ * Subtype 0x0018 - Send authorization request
+ *
+ * Sends a request for authorization to the given contact.  The request will either be
+ * granted, denied, or dropped.
+ *
+ */
+faim_export int aim_ssi_sendauthrequest(aim_session_t *sess, char *sn, char *msg)
+{
+	aim_conn_t *conn;
+	aim_frame_t *fr;
+	aim_snacid_t snacid;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)) || !sn)
+		return -EINVAL;
+
+	if (!(fr = aim_tx_new(sess, conn, AIM_FRAMETYPE_FLAP, 0x02, 10+1+strlen(sn)+2+(msg ? strlen(msg)+1 : 0)+2)))
+		return -ENOMEM;
+
+	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, AIM_CB_SSI_SENDAUTHREQ, 0x0000, NULL, 0);
+	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, AIM_CB_SSI_SENDAUTHREQ, 0x0000, snacid);
+
+	/* Screen name */
+	aimbs_put8(&fr->data, strlen(sn));
+	aimbs_putraw(&fr->data, sn, strlen(sn));
+
+	/* Message (null terminated) */
+	aimbs_put16(&fr->data, msg ? strlen(msg) : 0);
+	if (msg) {
+		aimbs_putraw(&fr->data, msg, strlen(msg));
+		aimbs_put8(&fr->data, 0x00);
+	}
+
+	/* Unknown */
+	aimbs_put16(&fr->data, 0x0000);
+
+	aim_tx_enqueue(sess, fr);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x0019 - Receive an authorization request
+ */
+static int receiveauthrequest(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	fu16_t tmp;
+	char *sn, *msg;
+
+	/* Read screen name */
+	if ((tmp = aimbs_get8(bs)))
+		sn = aimbs_getstr(bs, tmp);
+	else
+		sn = NULL;
+
+	/* Read message (null terminated) */
+	if ((tmp = aimbs_get16(bs)))
+		msg = aimbs_getstr(bs, tmp);
+	else
+		msg = NULL;
+
+	/* Unknown */
+	tmp = aimbs_get16(bs);
+
+	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+		ret = userfunc(sess, rx, sn, msg);
+
+	free(sn);
+	free(msg);
+
+	return ret;
+}
+
+/*
+ * Subtype 0x001a - Send authorization reply
+ *
+ * Sends a reply to a request for authorization.  The reply can either 
+ * grant authorization or deny authorization.
+ *
+ * if reply=0x00 then deny
+ * if reply=0x01 then grant
+ *
+ */
+faim_export int aim_ssi_sendauthreply(aim_session_t *sess, char *sn, fu8_t reply, char *msg)
+{
+	aim_conn_t *conn;
+	aim_frame_t *fr;
+	aim_snacid_t snacid;
+
+	if (!sess || !(conn = aim_conn_findbygroup(sess, AIM_CB_FAM_SSI)) || !sn)
+		return -EINVAL;
+
+	if (!(fr = aim_tx_new(sess, conn, AIM_FRAMETYPE_FLAP, 0x02, 10 + 1+strlen(sn) + 1 + 2+(msg ? strlen(msg)+1 : 0) + 2)))
+		return -ENOMEM;
+
+	snacid = aim_cachesnac(sess, AIM_CB_FAM_SSI, AIM_CB_SSI_SENDAUTHREP, 0x0000, NULL, 0);
+	aim_putsnac(&fr->data, AIM_CB_FAM_SSI, AIM_CB_SSI_SENDAUTHREP, 0x0000, snacid);
+
+	/* Screen name */
+	aimbs_put8(&fr->data, strlen(sn));
+	aimbs_putraw(&fr->data, sn, strlen(sn));
+
+	/* Grant or deny */
+	aimbs_put8(&fr->data, reply);
+
+	/* Message (null terminated) */
+	aimbs_put16(&fr->data, msg ? (strlen(msg)+1) : 0);
+	if (msg) {
+		aimbs_putraw(&fr->data, msg, strlen(msg));
+		aimbs_put8(&fr->data, 0x00);
+	}
+
+	/* Unknown */
+	aimbs_put16(&fr->data, 0x0000);
+
+	aim_tx_enqueue(sess, fr);
+
+	return 0;
+}
+
+/*
+ * Subtype 0x001b - Receive an authorization reply
+ * You get this bad boy when other people respond to the authorization 
+ * request that you have previously sent them.
+ */
+static int receiveauthreply(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	fu16_t tmp;
+	fu8_t reply;
+	char *sn, *msg;
+
+	/* Read screen name */
+	if ((tmp = aimbs_get8(bs)))
+		sn = aimbs_getstr(bs, tmp);
+	else
+		sn = NULL;
+
+	/* Read reply */
+	reply = aimbs_get8(bs);
+
+	/* Read message (null terminated) */
+	if ((tmp = aimbs_get16(bs)))
+		msg = aimbs_getstr(bs, tmp);
+	else
+		msg = NULL;
+
+	/* Unknown */
+	tmp = aimbs_get16(bs);
+
+	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+		ret = userfunc(sess, rx, sn, reply, msg);
+
+	free(sn);
+	free(msg);
+
+	return ret;
+}
+
+/*
+ * Subtype 0x001c - Receive a message telling you someone added you to their list.
+ */
+static int receiveadded(aim_session_t *sess, aim_module_t *mod, aim_frame_t *rx, aim_modsnac_t *snac, aim_bstream_t *bs)
+{
+	int ret = 0;
+	aim_rxcallback_t userfunc;
+	fu16_t tmp;
+	char *sn;
+
+	/* Read screen name */
+	if ((tmp = aimbs_get8(bs)))
+		sn = aimbs_getstr(bs, tmp);
+	else
+		sn = NULL;
+
+	if ((userfunc = aim_callhandler(sess, rx->conn, snac->family, snac->subtype)))
+		ret = userfunc(sess, rx, sn);
+
+	free(sn);
 
 	return ret;
@@ -1412,8 +1884,22 @@
 	else if (snac->subtype == AIM_CB_SSI_LIST)
 		return parsedata(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_ADD)
+		return parseadd(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_MOD)
+		return parsemod(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_DEL)
+		return parsedel(sess, mod, rx, snac, bs);
 	else if (snac->subtype == AIM_CB_SSI_SRVACK)
 		return parseack(sess, mod, rx, snac, bs);
 	else if (snac->subtype == AIM_CB_SSI_NOLIST)
 		return parsedataunchanged(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_RECVAUTH)
+		return receiveauthgrant(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_RECVAUTHREQ)
+		return receiveauthrequest(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_RECVAUTHREP)
+		return receiveauthreply(sess, mod, rx, snac, bs);
+	else if (snac->subtype == AIM_CB_SSI_ADDED)
+		return receiveadded(sess, mod, rx, snac, bs);
 
 	return 0;
@@ -1431,7 +1917,7 @@
 
 	mod->family = AIM_CB_FAM_SSI;
-	mod->version = 0x0001;
+	mod->version = 0x0004;
 	mod->toolid = 0x0110;
-	mod->toolversion = 0x047b;
+	mod->toolversion = 0x0629;
 	mod->flags = 0;
 	strncpy(mod->name, "ssi", sizeof(mod->name));
